
//std libs:
#include <vector>
#include <typeinfo>
#include <cxxabi.h>
#include <iostream>
#include <typeinfo>
#include <cstdlib>
#include "math.h"
#include <map>
#include <unordered_map> //needs c++11
#include <string>
#include <utility>

using namespace std;


int main(int argc, char **argv){
  
  int Ebins = 1;
  int NBins=15;  
  double low=150;
  double up=2100;  
  double current_lowE = low;
  double addingfraction=0.25;
  
  vector<double> binEdges;
  binEdges.push_back( low );
  double binwidth= (up-low)/NBins;
  Ebins = 1;
  
  while( current_lowE < up ){    
    if(addingfraction!=0){
      binwidth = addingfraction * current_lowE;
      current_lowE += binwidth;}
    else{
      current_lowE += binwidth;}
    
    binEdges.push_back( current_lowE );
    cout<<"current_lowE"<<current_lowE<<endl;
  }
  
  cout<<"binEdges.size() "<<binEdges.size()<<endl;

  //this puts it on the heap and causes a crahs. It seems it doesn't allocate properly
  float * Ebins_var;
  Ebins_var = new float(binEdges.size());

  //this allocates it on the stack and it works
  //  double Ebins_var[binEdges.size()];

  //here we assign to Ebins_var. for 
  for(int i = 0; i < binEdges.size(); i++){
    cout<<"iterator is at "<<i<<" addresses &binEdges[i] "<<&binEdges[i]<<" &Ebins_var[i] "<< &Ebins_var[i]<<endl;
    Ebins_var[i] = binEdges[i];}
  
  Ebins = binEdges.size()-1;
  cout<<"Ebins "<<Ebins<<endl;

  //prompt the output:
  for(int i = 0; i < binEdges.size(); i++){
    cout<<"i "<<i<<" Ebins_var[i] "<<Ebins_var[i]<<endl;}
  
  
  cout<<"program reached end type eneter to terminate"<<endl;
  char c;
  std::cin >> c;
  
  return 0;
} //closes macro


